/* DSP LABORATORY 
 * University of Technology Graz, 2018
 * Josef Kulmer
 */


#ifndef IIR2_H
#define IIR2_H

#include <vector>
#include <math.h>

using std::vector;

class iir2{
private:
    vector<short> bufferin;      // internal buffer
    vector<short> bufferout;     // output buffer 
    vector<short> x;
    vector<short> y;
    
    // filter coefficients
    int a0; 
    int a1;
    int a2;
    int b0;
    int b1;
    int b2;
public:
    // constructor
    iir2();
    ~iir2();
    // set coefficients
    void setCoefficients();
    // perform filtering
    void doFiltering(const void *, void *);
    
    static const int Q15 = 32768;
};

#endif /* IIR2_H */

